## moon 2.2

=== Makefile ===
thisdir := .

SUBDIRS := build man class tools vbnc vbruntime scripts

include build/rules.make

all-recursive $(STD_TARGETS:=-recursive): platform-check profile-check

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

DISTFILES = README configure mkinstalldirs install-sh LICENSE

# fun specialty targets

PROFILES = default net_2_0

.PHONY: all-profiles $(STD_TARGETS:=-profiles)
all-profiles $(STD_TARGETS:=-profiles): %-profiles: profiles-do--%
	@:

profiles-do--%:
	$(MAKE) $(PROFILES:%=profile-do--%--$*)

# The % below looks like profile-name--target-name
profile-do--%:
	$(MAKE) PROFILE=$(subst --, ,$*)

# We don't want to run the tests in parallel.  We want behaviour like -k.
profiles-do--run-test:
	ret=:; $(foreach p,$(PROFILES), { $(MAKE) PROFILE=$(p) run-test || ret=false; }; ) $$ret

# Orchestrate the bootstrap here.
_boot_ = all clean install
$(_boot_:%=profile-do--net_2_0--%):           profile-do--net_2_0--%:           profile-do--net_2_0_bootstrap--%
$(_boot_:%=profile-do--net_2_0_bootstrap--%): profile-do--net_2_0_bootstrap--%: profile-do--default--%
$(_boot_:%=profile-do--default--%):           profile-do--default--%:           profile-do--net_1_1_bootstrap--%
$(_boot_:%=profile-do--net_1_1_bootstrap--%): profile-do--net_1_1_bootstrap--%: profile-do--basic--%

testcorlib:
	@cd class/corlib && $(MAKE) test run-test

compiler-tests:
	$(MAKE) TEST_SUBDIRS="tests errors" run-test-profiles

test-installed-compiler:
	$(MAKE) TEST_SUBDIRS="tests errors" PROFILE=default TEST_RUNTIME=mono MCS=mcs run-test
	$(MAKE) TEST_SUBDIRS="tests errors" PROFILE=net_2_0 TEST_RUNTIME=mono MCS=gmcs run-test

package := mono-basic-$(VERSION)

dist-local: dist-default

dist-pre:
	rm -rf $(package)
	mkdir $(package)

dist-tarball: dist-pre
	$(MAKE) distdir='$(package)' dist-recursive
	tar cvjf $(package).tar.bz2 $(package)

dist: dist-tarball
	rm -rf $(package)

# the egrep -v is kind of a hack (to get rid of the makefrags)
# but otherwise we have to make dist then make clean which
# is sort of not kosher. And it breaks with DIST_ONLY_SUBDIRS.
#
# We need to set prefix on make so class/System/Makefile can find
# the installed System.Xml to build properly

distcheck: dist-tarball
	rm -rf InstallTest Distcheck-MONOBASIC ; \
	mkdir InstallTest ; \
	destdir=`cd InstallTest && pwd` ; \
	mv $(package) Distcheck-MONOBASIC ; \
	(cd Distcheck-MONOBASIC && \
	    ./configure --prefix=$(prefix) && \
	    $(MAKE) prefix=$(prefix) && $(MAKE) test && $(MAKE) install DESTDIR="$$destdir" && \
	    $(MAKE) clean && $(MAKE) dist || exit 1) || exit 1 ; \
	mv Distcheck-MONOBASIC $(package) ; \
	tar tjf $(package)/$(package).tar.bz2 |sed -e 's,/$$,,' |sort >distdist.list ; \
	rm $(package)/$(package).tar.bz2 ; \
	tar tjf $(package).tar.bz2 |sed -e 's,/$$,,' |sort >before.list ; \
	find $(package) |egrep -v '(makefrag|response|config.make)' |sed -e 's,/$$,,' |sort >after.list ; \
	cmp before.list after.list || exit 1 ; \
	cmp before.list distdist.list || exit 1 ; \
	rm -f before.list after.list distdist.list ; \
	rm -rf $(package) InstallTest

vbnc: vbnc.in Makefile
	sed -e s,@prefix@,$(prefix),g < vbnc.in > $@.tmp
	mv $@.tmp $@

=== class/Makefile ===
thisdir = class

include ../build/rules.make

lib/bootstrap lib/vbnc:
	$(MKINSTALLDIRS) $@

DISTFILES = \
	mono.snk	\
	lib/bootstrap/Microsoft.VisualBasic.dll lib/bootstrap/vbnc.exe lib/bootstrap/vbnc.rsp	

dist-default: lib/bootstrap/Microsoft.VisualBasic.dll lib/bootstrap/vbnc.exe lib/bootstrap/vbnc.rsp

DIST_PROFILE_DIRS = bootstrap vbnc

dist-local: dist-default
	-$(MKINSTALLDIRS) $(DIST_PROFILE_DIRS:%=$(distdir)/lib/%) $(COMPAT_PROFILE_DIRS:%=$(distdir)/compat/%)

clean-local test-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local:
	@:

=== mcs/Makefile ===
thisdir := .

SUBDIRS := build jay mcs class nunit24 ilasm tools tests errors docs

basic_SUBDIRS := build jay mcs class
net_1_1_bootstrap_SUBDIRS := build jay mcs class ilasm tools
net_2_0_bootstrap_SUBDIRS := build jay mcs class ilasm tools
net_2_0_SUBDIRS := build jay mcs class nunit24 ilasm tools tests errors docs
net_2_1_bootstrap_SUBDIRS := build mcs class
net_2_1_raw_SUBDIRS := build mcs class tools
net_2_1_SUBDIRS := tools tests errors
monotouch_SUBDIRS := build mcs class
monotouch_bootstrap_SUBDIRS := build mcs class
net_3_5_SUBDIRS := build class
net_4_0_bootstrap_SUBDIRS := build mcs class tools
net_4_0_SUBDIRS := build mcs class nunit24 ilasm tools tests errors

# List of test subdirs that should pass 100%
centum_tests := \
	class/corlib						\
	class/System						\
	class/System.XML					\
	class/Commons.Xml.Relaxng				\
	class/Cscompmgd						\
	class/Microsoft.JScript					\
	class/Mono.Posix					\
	class/Mono.Security					\
	class/System.Design					\
	class/System.DirectoryServices		\
	class/System.Drawing				\
	class/System.Runtime.Remoting				\
	class/System.Runtime.Serialization.Formatters.Soap	\
	class/System.Security					\
	class/System.ServiceProcess				\
	class/System.Web						\
	class/System.Web.Services				\
	tests							\
	errors

default_centum_tests := \
	$(centum_tests) 	\
	class/System.Data

net_2_0_centum_tests := \
	$(centum_tests)				\
	class/System.Core			\
	class/System.Configuration		\
	class/System.Data.DataSetExtensions	\
	class/System.Xml.Linq			\
	class/System.Transactions		\
	class/Microsoft.Build.Framework		\
	class/Microsoft.Build.Utilities		\
	class/Microsoft.Build.Engine		\
	class/System.Runtime.Serialization	\
	class/System.IdentityModel		\
	class/System.ServiceModel.Web		\
	class/Mono.C5

#	class/System.Web.Extensions
#	class/Microsoft.Build.Tasks	

# note that System.Xml.Linq is here to prevent this from being empty
net_3_5_centum_tests := \
	class/System.Xml.Linq

ifdef ONLY_CENTUM_TESTS
TEST_SUBDIRS := $($(PROFILE)_centum_tests)
endif

ifdef TEST_SUBDIRS
$(PROFILE)_SUBDIRS := $(TEST_SUBDIRS)
endif

include build/rules.make

all-recursive $(STD_TARGETS:=-recursive): dir-check platform-check profile-check

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

dir-check:
	@if [ "$(NO_DIR_CHECK)" = "" -a "$(PROFILE)" != "basic" ]; then echo "Running make from the mcs directory is not supported. Run make from the parent directory (if using a tarball), or from the directory where the runtime is checked out (if using an SVN checkout)."; exit 1; fi

# fun specialty targets

PROFILES = net_1_1 net_2_0 net_3_5 net_4_0

.PHONY: all-profiles $(STD_TARGETS:=-profiles)
all-profiles $(STD_TARGETS:=-profiles): %-profiles: profiles-do--%
	@:

profiles-do--%:
	$(MAKE) $(PROFILES:%=profile-do--%--$*)

# The % below looks like profile-name--target-name
profile-do--%:
	$(MAKE) PROFILE=$(subst --, ,$*)

# We don't want to run the tests in parallel.  We want behaviour like -k.
profiles-do--run-test:
	ret=:; $(foreach p,$(PROFILES), { $(MAKE) PROFILE=$(p) run-test || ret=false; }; ) $$ret

# Orchestrate the bootstrap here.
_boot_ = all clean install
$(_boot_:%=profile-do--net_4_0--%):           profile-do--net_4_0--%:           profile-do--net_4_0_bootstrap--%
$(_boot_:%=profile-do--net_4_0_bootstrap--%): profile-do--net_4_0_bootstrap--%: profile-do--net_2_0--%
$(_boot_:%=profile-do--net_3_5--%):           profile-do--net_3_5--%:           profile-do--net_2_0--%
$(_boot_:%=profile-do--net_2_1--%):           profile-do--net_2_1--%:           profile-do--net_2_1_raw--%
$(_boot_:%=profile-do--monotouch--%):         profile-do--monotouch--%:         profile-do--monotouch_bootstrap--%
$(_boot_:%=profile-do--monotouch_bootstrap--%): profile-do--monotouch_bootstrap--%: profile-do--net_2_0--%
$(_boot_:%=profile-do--net_2_1_raw--%):       profile-do--net_2_1_raw--%:       profile-do--net_2_1_bootstrap--%
$(_boot_:%=profile-do--net_2_1_bootstrap--%): profile-do--net_2_1_bootstrap--%: profile-do--net_2_0--%
$(_boot_:%=profile-do--net_2_0--%):           profile-do--net_2_0--%:           profile-do--net_2_0_bootstrap--%
$(_boot_:%=profile-do--net_2_0_bootstrap--%): profile-do--net_2_0_bootstrap--%: profile-do--net_1_1_bootstrap--%
$(_boot_:%=profile-do--net_1_1--%):           profile-do--net_1_1--%:           profile-do--net_1_1_bootstrap--%
$(_boot_:%=profile-do--net_1_1_bootstrap--%): profile-do--net_1_1_bootstrap--%: profile-do--basic--%

testcorlib:
	@cd class/corlib && $(MAKE) test run-test

compiler-tests:
	$(MAKE) TEST_SUBDIRS="tests errors" run-test-profiles

test-installed-compiler:
	$(MAKE) TEST_SUBDIRS="tests errors" PROFILE=net_1_1 TEST_RUNTIME=mono MCS=mcs run-test
	$(MAKE) TEST_SUBDIRS="tests errors" PROFILE=net_2_0 TEST_RUNTIME=mono MCS=gmcs run-test

package := mcs-$(VERSION)

DISTFILES = \
	AUTHORS			\
	ChangeLog		\
	COPYING			\
	COPYING.LIB		\
	INSTALL.txt		\
	LICENSE			\
	LICENSE.GPL		\
	LICENSE.LGPL		\
	LICENSE.MPL		\
	Makefile		\
	mkinstalldirs		\
	MIT.X11			\
	MonoIcon.png		\
	README			\
	ScalableMonoIcon.svg	\
	winexe.in		\
	nunit.key

dist-local: dist-default

dist-pre:
	rm -rf $(package)
	mkdir $(package)

dist-tarball: dist-pre
	$(MAKE) distdir='$(package)' dist-recursive
	tar cvjf $(package).tar.bz2 $(package)

dist: dist-tarball
	rm -rf $(package)

# the egrep -v is kind of a hack (to get rid of the makefrags)
# but otherwise we have to make dist then make clean which
# is sort of not kosher. And it breaks with DIST_ONLY_SUBDIRS.
#
# We need to set prefix on make so class/System/Makefile can find
# the installed System.Xml to build properly

distcheck: dist-tarball
	rm -rf InstallTest Distcheck-MCS ; \
	mkdir InstallTest ; \
	destdir=`cd InstallTest && pwd` ; \
	mv $(package) Distcheck-MCS ; \
	(cd Distcheck-MCS && \
	    $(MAKE) prefix=$(prefix) && $(MAKE) test && $(MAKE) install DESTDIR="$$destdir" && \
	    $(MAKE) clean && $(MAKE) dist || exit 1) || exit 1 ; \
	mv Distcheck-MCS $(package) ; \
	tar tjf $(package)/$(package).tar.bz2 |sed -e 's,/$$,,' |sort >distdist.list ; \
	rm $(package)/$(package).tar.bz2 ; \
	tar tjf $(package).tar.bz2 |sed -e 's,/$$,,' |sort >before.list ; \
	find $(package) |egrep -v '(makefrag|response)' |sed -e 's,/$$,,' |sort >after.list ; \
	cmp before.list after.list || exit 1 ; \
	cmp before.list distdist.list || exit 1 ; \
	rm -f before.list after.list distdist.list ; \
	rm -rf $(package) InstallTest

monocharge:
	chargedir=monocharge-`date -u +%Y%m%d` ; \
	mkdir "$$chargedir" ; \
	DESTDIR=`cd "$$chargedir" && pwd` ; \
	$(MAKE) install DESTDIR="$$DESTDIR" || exit 1 ; \
	tar cvjf "$$chargedir".tar.bz2 "$$chargedir" ; \
	rm -rf "$$chargedir"

# A bare-bones monocharge.

monocharge-lite:
	chargedir=monocharge-lite-`date -u +%Y%m%d` ; \
	mkdir "$$chargedir" ; \
	DESTDIR=`cd "$$chargedir" && pwd` ; \
	$(MAKE) -C mcs install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/corlib install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/System install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/System.XML install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/Mono.CSharp.Debugger install DESTDIR="$$DESTDIR" || exit 1; \
	tar cvjf "$$chargedir".tar.bz2 "$$chargedir" ; \
	rm -rf "$$chargedir"

=== vbnc/Makefile ===
thisdir := vbnc
SUBDIRS := vbnc

ac_files =	\
	"ac/My Project/Resources.Designer.vb"	\
	"ac/My Project/Settings.settings"	\
	"ac/My Project/AssemblyInfo.vb"		\
	"ac/My Project/Settings.Designer.vb"	\
	"ac/My Project/Application.Designer.vb"	\
	"ac/My Project/Application.myapp"	\
	"ac/My Project/Resources.resx"		\
	ac/License.txt				\
	ac/ac.vbproj				\
	ac/Startup.vb				\
	ac/ac.sln				\
	ac/AssemblyComparer.vb

rt_files = \
	rt/Makefile \
	rt/ChangeLog \
	rt/Readme.txt \
	rt/rt.exe.sources \
	$(wildcard rt/source/*)

rt_execute_files = \
	rt-execute/ChangeLog \
	rt-execute/Makefile \
	rt-execute/rt-execute.vb \
	rt-execute/rt-execute.vbproj \
	rt-execute/rt-execute.exe.sources

rt_console_files = \
	rt-console/ChangeLog \
	rt-console/Makefile \
	rt-console/Readme.txt \
	rt-console/rt-console.vbproj \
	rt-console/rt-console.exe.sources \
	$(wildcard rt-console/source/*)

	
EXTRA_DISTFILES = 			\
	all.sln				\
	changelog.txt			\
	CheckLicense.vbs		\
	clean.bat			\
	"License FileHeader.txt"	\
	License.txt			\
	progress.txt			\
	$(ac_files)			

DISTFILES =				\
	$(rt_files)			\
	$(rt_execute_files)		\
	$(rt_console_files)

include ../build/rules.make

clean-local test-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local:
	@:

dist-local: dist-default

=== vbruntime/Makefile ===
thisdir = vbruntime
include ../build/rules.make

SUBDIRS := Microsoft.VisualBasic Test

DISTFILES = Makefile VB.build.bat

clean-local test-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local:
	@:

dist-local: dist-default

=== mcs/build/Makefile ===
thisdir = build
SUBDIRS = 
include ../build/rules.make

BUILT_FILES = common/Consts.cs

all-local install-local test-local run-test-local run-test-ondotnet-local uninstall-local doc-update-local: $(BUILT_FILES)
	@:

clean-local:
	-rm -f $(BUILT_FILES) deps/*

common/Consts.cs: common/Consts.cs.in $(wildcard config.make)
	test -n '$(MONO_VERSION)'
	sed -e 's,@''MONO_VERSION@,$(MONO_VERSION),' $< > $@

PLATFORMS = darwin linux win32
PROFILES = \
	basic \
	net_1_1_bootstrap \
	net_1_1	\
	net_2_0_bootstrap \
	net_2_0 \
	net_2_1_bootstrap \
	net_2_1_raw \
	net_2_1 \
	net_1_0	\
	net_3_5	\
	net_4_0_bootstrap \
	net_4_0	

COMMON_SRCS = \
	Consts.cs.in			\
	Locale.cs			\
	MonoTODOAttribute.cs

DISTFILES = \
	README.makefiles		\
	README.platforms		\
	README.configury		\
	config-default.make		\
	corcompare.make			\
	corcompare-api.xsl		\
	executable.make			\
	library.make			\
	nunit-summary.xsl		\
	rules.make			\
	tests.make			\
	$(COMMON_SRCS:%=common/%)	\
	$(PLATFORMS:%=platforms/%.make) $(PROFILES:%=profiles/%.make)

dist-local: dist-default

=== mcs/mcs/Makefile ===
thisdir := mcs
SUBDIRS := 
include ../build/rules.make

EXTRA_DISTFILES = \
	*mcs.csproj		\
	compiler.doc		\
	*mcs.sln		\
	*cs-parser.jay		\
	*.sources		\
	generic.cs		\
	NOTES			\
	TODO			\
	*mcs.exe.config

ifeq (1.0, $(FRAMEWORK_VERSION))
COMPILER_NAME = mcs
endif

ifeq (2.0, $(FRAMEWORK_VERSION))
LOCAL_MCS_FLAGS += -d:GMCS_SOURCE
COMPILER_NAME = gmcs
endif

ifeq (2.1, $(FRAMEWORK_VERSION))
LOCAL_MCS_FLAGS += -d:GMCS_SOURCE -d:SMCS_SOURCE
COMPILER_NAME = smcs
endif

ifeq (4.0, $(FRAMEWORK_VERSION))
LOCAL_MCS_FLAGS += -d:GMCS_SOURCE
COMPILER_NAME = dmcs
endif

PROGRAM = $(topdir)/class/lib/$(PROFILE)/$(COMPILER_NAME).exe

BUILT_SOURCES = cs-parser.cs

PROGRAM_COMPILE = $(BOOT_COMPILE)

CLEAN_FILES += y.output

%-parser.cs: %-parser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -cvt < $(topdir)/jay/skeleton.cs $< > jay-tmp.out && mv jay-tmp.out $@


ifeq (net_2_0_bootstrap, $(PROFILE))

all-local $(STD_TARGETS:=-local):
	@:

all-local: $(PROGRAM) $(PROGRAM).config
clean-local: clean-program
clean-program:
	rm -f $(PROGRAM) $(PROGRAM).config

$(PROGRAM) $(PROGRAM).config: $(dir $(PROGRAM))/.stamp

$(PROGRAM): $(topdir)/class/lib/$(BOOTSTRAP_PROFILE)/mcs.exe
	cp $< $@

$(PROGRAM).config: gmcs.exe.config
	cp $< $@

else

ifeq (net_2_0, $(PROFILE))

BOOTSTRAP_MCS = MONO_PATH="$(topdir)/class/lib/net_2_0_bootstrap$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/net_2_0_bootstrap/gmcs.exe $(DEBUG_FLAGS)

clean-local: clean-net_2_0_bootstrap
clean-net_2_0_bootstrap:
	cd .. && $(MAKE) NO_DIR_CHECK=yes PROFILE=net_2_0_bootstrap clean

bootstrap_libs = mscorlib.dll System.dll System.Xml.dll Mono.CompilerServices.SymbolWriter.dll
bootstrap_libfiles = $(bootstrap_libs:%=$(topdir)/class/lib/net_2_0_bootstrap/%)

$(bootstrap_libfiles): bootstrap-libs
	@:
.PHONY: bootstrap-libs
bootstrap-libs:
	cd .. && $(MAKE) NO_DIR_CHECK=yes PROFILE=net_2_0_bootstrap all

$(PROGRAM): $(bootstrap_libfiles)
endif

KEEP_OUTPUT_FILE_COPY = yes

include ../build/executable.make
endif

csproj-local:
	config_file=`basename $(PROGRAM) .exe`-$(PROFILE).input; \
	echo $(thisdir):$$config_file >> $(topdir)/../mono/msvc/scripts/order; \
	(echo $(is_boot); \
	echo $(BOOTSTRAP_MCS);	\
	echo $(USE_MCS_FLAGS) $(LIBRARY_FLAGS) $(LIB_MCS_FLAGS); \
	echo $(PROGRAM); \
	echo $(BUILT_SOURCES); \
	echo $(PROGRAM); \
	echo $(response)) > $(topdir)/../mono/msvc/scripts/inputs/$$config_file

#
# Below this line we have local targets used for testing and development
#

# Testing targets

TIME = time

# This used to be called test, but that conflicts with the global
# recursive target.

btest: mcs2.exe mcs3.exe
	ls -l mcs2.exe mcs3.exe

mcs2.exe: $(PROGRAM)
	$(TIME) $(RUNTIME) $(RUNTIME_FLAGS) $(PROGRAM) $(USE_MCS_FLAGS) -target:exe -out:$@ $(BUILT_SOURCES) @$(response)

mcs3.exe: mcs2.exe
	$(TIME) $(RUNTIME) $(RUNTIME_FLAGS) ./mcs2.exe $(USE_MCS_FLAGS) -target:exe -out:$@ $(BUILT_SOURCES) @$(response)

wc:
	wc -l $(BUILT_SOURCES) `cat $(sourcefile)`

ctest: 
	rm -f mcs2.exe mcs3.exe
	$(MAKE) USE_MCS_FLAGS="-d:NET_1_1 -d:ONLY_1_1" btest

# we need this because bash tries to use its own crappy timer
FRIENDLY_TIME = $(shell which time) -f'%U seconds'

do-time : $(PROGRAM)
	@ echo -n "Run 1:   "
	@ rm -f mcs2.exe
	@ $(MAKE) TIME="$(FRIENDLY_TIME)" mcs2.exe > /dev/null || (echo FAILED; exit 1)
	@ echo -n "Run 2:   "
	@ rm -f mcs3.exe
	@ $(MAKE) TIME="$(FRIENDLY_TIME)" mcs3.exe > /dev/null || (echo FAILED; exit 1)
	@ $(MAKE) do-corlib

do-corlib:
	@ echo -n "corlib:  "
	@ rm -f ../class/lib/mscorlib.dll
	@ cd ../class/corlib ; $(MAKE) BOOTSTRAP_MCS='$(FRIENDLY_TIME) mono $$(topdir)/class/lib/$(PROFILE)/mcs.exe' > /dev/null || (echo FAILED; exit 1)

PROFILER=default

do-gettext:
	xgettext --keyword='Report.Error:3' --keyword='Report.Error:2' --keyword='Report.Warning:3' --keyword='Report.Warning:2' -o mcs.po --language='C#' `cat gmcs.exe.sources | grep -v /`

profile : $(PROGRAM)
	$(RUNTIME) $(RUNTIME_FLAGS) --profile=$(PROFILER) $(PROGRAM) $(USE_MCS_FLAGS) -target:exe -out:mcs2.exe $(BUILT_SOURCES) @$(response)

#
# quick hack target, to quickly develop the gmcs compiler
# Update manually.
qh:
	MONO_PATH="../class/lib/net_2_0$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) ../class/lib/net_2_0/gmcs.exe  /codepage:65001 -d:GMCS_SOURCE  -d:NET_1_1 -d:NET_2_0 -debug -target:exe -out:gmcs.exe cs-parser.cs  @gmcs.exe.sources
	@ cp $(COMPILER_NAME).exe* $(topdir)/class/lib/$(PROFILE)/

pa: cs-parser.cs
	MONO_PATH="../class/lib/net_2_0$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) ../class/lib/net_2_0/gmcs.exe  /codepage:65001 -d:GMCS_SOURCE  -d:NET_1_1 -d:NET_2_0 -debug -target:exe -out:foo.exe cs-parser.cs foo.cs -main:X  @gmcs.exe.sources

q: cs-parser.cs qh
	echo 'System.Console.WriteLine ("Hello");' | mono csharp.exe
	echo -e 'using System;\nConsole.WriteLine ("hello");' | mono csharp.exe
	echo -e '"foo" == "bar";' | mono csharp.exe
	echo -e 'var a = 1;\na + 2;' | mono csharp.exe
	echo -e 'int j;\nj = 1;' | mono csharp.exe
	echo -e 'var a = new int[]{1,2,3};\nfrom x in a select x;' | mono csharp.exe
	echo -e 'var a = from f in System.IO.Directory.GetFiles ("/tmp") where f == "passwd" select f;' | mono csharp.exe

=== mcs/tests/Makefile ===
#
# use make run-test PROFILE=net_2_0
#

thisdir = tests
SUBDIRS =
include ../build/rules.make

DISTFILES = README.tests $(wildcard dlls/**/*.cs)
DISTFILES += $(wildcard *.cs) $(wildcard *.il) $(wildcard *.xml) $(wildcard *.inc) $(wildcard known-issues-*) $(wildcard *.snk)

with_mono_path = MONO_PATH="$(topdir)/class/lib/$(PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH"

ifeq (net_1_1, $(PROFILE))
# force this, we don't case if CSC is broken. This also
# means we can use --options, yay.
MCS = $(with_mono_path) $(INTERNAL_MCS)
endif
ilasm = $(topdir)/class/lib/net_1_1_bootstrap/ilasm.exe
ILASM = MONO_PATH="$(topdir)/class/lib/net_1_1_bootstrap$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(ilasm)

ifeq (net_2_0, $(PROFILE))
BOOTSTRAP_MCS = MONO_PATH="$(topdir)/class/lib/net_2_0_bootstrap$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/net_2_0_bootstrap/mcs.exe
endif

USE_MCS_FLAGS :=

# mention all targets
all-local $(STD_TARGETS:=-local):

VALID_PROFILE := $(filter net_1_1 net_2_0 net_2_1 net_4_0, $(PROFILE))
ifdef VALID_PROFILE
# casts
bootstrap-cast.exe: gen-cast-test.cs
	$(BOOT_COMPILE) -target:exe /out:$@ $<

casts.cs: bootstrap-cast.exe
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $< >$@

casts-mcs.exe: casts.cs
	$(CSCOMPILE) -target:exe /out:$@ $<

casts-boot.exe: casts.cs
	$(BOOT_COMPILE) -target:exe /out:$@ $<

boot-casts.out: casts-boot.exe
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $< >$@

mcs-casts.out: casts-mcs.exe
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $< >$@

test-casts: boot-casts.out mcs-casts.out
	cmp $^
	-rm -f bootstrap-cast.exe casts.cs casts-boot.exe casts-mcs.exe boot-casts.out mcs-casts.out

eval.exe: eval-tests.cs

ifeq (net_4_0, $(PROFILE))
COMPILER_NAME = dmcs
TEST_PATTERN = 'v4'
LOCAL_RUNTIME_FLAGS = --verify-all
#TOPTIONS += '-il:ver-il-dmcs.xml'
endif
ifeq (net_2_1, $(PROFILE))
COMPILER_NAME = smcs
TEST_PATTERN = 'v2'
LOCAL_RUNTIME_FLAGS = --security=temporary-smcs-hack
endif
ifeq (net_2_0, $(PROFILE))
COMPILER_NAME = gmcs
TEST_PATTERN = 'v2'
LOCAL_RUNTIME_FLAGS = --verify-all
TOPTIONS += '-il:ver-il-gmcs.xml'
endif
ifeq (net_1_1, $(PROFILE))
COMPILER_NAME = mcs
TEST_PATTERN = 'v1'
LOCAL_RUNTIME_FLAGS = --verify-all
endif

COMPILER = $(topdir)/class/lib/$(PROFILE)/$(COMPILER_NAME).exe
TESTER = MONO_RUNTIME='$(RUNTIME)' $(TEST_RUNTIME) $(RUNTIME_FLAGS) $(LOCAL_RUNTIME_FLAGS) $(topdir)/class/lib/$(PROFILE)/compiler-tester.exe

TEST_ILS := $(wildcard *-lib.il)

ifeq (net_2_0, $(PROFILE))
eval-test: 
	$(CSCOMPILE) eval-test.cs -r:$(COMPILER)
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) eval-test.exe
else
eval-test:
endif

check: run-test

test-local:
	@:

run-test-local: $(TEST_ILS:.il=.dll) eval-test
	$(TESTER) -mode:pos -files:$(TEST_PATTERN) -compiler:$(COMPILER) -issues:known-issues-$(COMPILER_NAME) -log:$(COMPILER_NAME).log $(TOPTIONS)

# Temporary testing targets
cecil:
	rm -f *.mdb
	$(TESTER) -mode:pos -files:'test-*.cs' -compiler:gmcs.exe -issues:known-issues-$(COMPILER_NAME) -log:$(COMPILER_NAME).log -verbose

cecil2:
	rm -f *.mdb
	$(TESTER) -mode:pos -files:'*test-*.cs' -compiler:gmcs.exe -issues:known-issues-$(COMPILER_NAME) -log:$(COMPILER_NAME).log -verbose
# End	

test-everything:
	$(MAKE) PROFILE=net_1_1 run-test
	$(MAKE) PROFILE=net_2_0 run-test

test-generics:
	$(MAKE) PROFILE=net_2_0 run-test

clean-local:
	-rm -fr dir-*
	-rm -f *.exe *.dll *.netmodule *.out *.pdb *.mdb casts.cs *.log
	-rm -f xml-*.xml

dist-local: dist-default
	rm -f $(distdir)/casts.cs

%-il.dll: %-il.il
	$(ILASM) /dll $<

%-lib.dll: %-lib.il
	$(ILASM) /dll /out:$@ $<

ifeq (net_1_1, $(PROFILE))
run-test-local: ilasm
ilasm:
	$(ILASM) /dll property-il.il
	$(CSCOMPILE) /r:property-il.dll property-main.cs /out:property-main.exe
	$(TEST_RUNTIME) property-main.exe

	$(CSCOMPILE) -t:library dlls/test-679-2/test-679-lib-2.cs
	$(CSCOMPILE) -t:library dlls/test-679-1/test-679-lib.cs -r:dlls/test-679-2/test-679-lib-2.dll
endif

endif

=== mcs/tools/Makefile ===
thisdir = tools

net_1_1_dirs := \
	al			\
	cilc		\
	culevel		\
	ictool		\
	mono-xsd	\
	security	\
	wsdl		\
	genxs		\
	disco		\
	soapsuds	\
	browsercaps-updater	\
	monop		\
	gacutil		\
	cil-strip	\
	resgen		\
	macpack		\
	mkbundle	\
	dtd2rng		\
	dtd2xsd		\
	mjs			\
	prj2make	\
	mono-service	\
	monodoc		\
	mod		\
	compiler-tester	\
	installvst		\
	installutil

net_2_0_dirs := \
	al			\
	corcompare	\
	linker		\
	tuner		\
	csharplib	\
	csharp		\
	mono-xsd	\
	wsdl		\
	mono-xmltool	\
	compiler-tester	\
	monop		\
	xbuild		\
	resgen		\
	mdoc		\
	mono-service	\
	mono-shlib-cop	\
	mkbundle	\
	sgen		\
	security	\
	mconfig		\
	installutil	\
	nunitreport	\
	pdb2mdb		\
	sqlsharp	\
	sqlmetal	\
	gacutil		\
	svcutil		\
	lc

net_2_1_dirs := \
	compiler-tester
	
net_1_1_bootstrap_SUBDIRS = gacutil security resgen culevel
net_1_1_SUBDIRS := $(net_1_1_dirs)
net_2_0_bootstrap_SUBDIRS = resgen
net_2_0_SUBDIRS := $(net_2_0_dirs)
net_2_1_raw_SUBDIRS := $(net_2_1_dirs)
net_2_1_SUBDIRS := $(net_2_1_dirs)
net_4_0_bootstrap_SUBDIRS = resgen
net_4_0_SUBDIRS := $(net_2_0_dirs)

SUBDIRS = $(net_1_1_SUBDIRS) $(net_2_0_SUBDIRS) $(net_2_1_SUBDIRS)

include ../build/rules.make

DISTFILES = \
	assemblies.xml			\
	mono-win32-setup-dark.bmp	\
	mono-win32-setup-light.bmp	\
	mono-win32-setup.nsi		\
	scan-tests.pl			\
	tinderbox/smtp.c		\
	tinderbox/tinderbox.sh		\
	gensources.sh			\
	removecomments.sh

test-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local doc-update-local:
	@:

dist-local: dist-default

clean-local:
	rm -f *.exe *.dll *.pdb cormissing.xml

=== vbnc/vbnc/Makefile ===
thisdir = vbnc/vbnc
SUBDIRS = tests
include ../../build/rules.make

LOCAL_VBNC_FLAGS = @vbnc.exe.rsp $(EXTERNAL_VBNC_FLAGS)

PROGRAM = $(topdir)/class/lib/vbnc/vbnc.exe
PROGRAM_COMPILE = $(BOOT_COMPILE)

include ../../build/executable.make
DISTFILES = \
	Makefile  		\
	Readme.txt  		\
	vbnc.Errors.resources	\
	vbnc.exe.rsp  		\
	vbnc.exe.sources  	\
	vbnc.sln  		\
	vbnc.vbnc.rsp		\
	source/vbnc.vbproj	\
	source/vbnc9.vbproj	\
	bin/vbnc.rsp            \
	source/Resources/Errors.resx \
	source/vbnc.rsp		\
	setversion.sh

version.tmp: $(topdir)/configure setversion.sh
	-$(topdir)/vbnc/vbnc/setversion.sh $(topdir)/vbnc/vbnc/source/General/Version.vb

all-local: vbnc.Errors.resources vbnc.exe.sources version.tmp

vbnc.Errors.resources: source/Resources/Errors.resx
	resgen2 source/Resources/Errors.resx vbnc.Errors.resources

vbnc.vbnc.rsp: source/vbnc.rsp
	cp source/vbnc.rsp vbnc.vbnc.rsp

vbnc.exe.sources: vbnc.vbnc.rsp source/vbnc9.vbproj vbnc.Errors.resources
	MONO_PATH="../../class/lib/bootstrap$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" mono ../../tools/extract-source/extract-source.exe -s:source/vbnc9.vbproj -d:vbnc.exe.sources -m:l -b:source/ -x:r

install-local: install-extras version.tmp
install-extras: 
	$(MKINSTALLDIRS) $(DESTDIR)$(PROGRAM_INSTALL_DIR)
	$(INSTALL_DATA) bin/vbnc.rsp $(DESTDIR)$(PROGRAM_INSTALL_DIR)

uninstall-local: uninstall-extras
uninstall-extras:
	rm -f $(DESTDIR)$(PROGRAM_INSTALL_DIR)/vbnc.rsp

install-binary: default
	cp ../../class/lib/vbnc/vbnc.* ../../class/lib/bootstrap

boot-from-ms:
	cd tests/SelfTest/ && boot.sh && rerun.sh
	cp tests/SelfTest/vbnc.exe ../../class/lib/bootstrap
	
test-thorough:
	cd tests/SelfTest/ && updatesources.sh
	cd tests/SelfTest/ && rerun.sh && rerun.sh && rerun.sh
	cp tests/SelfTest/vbnc.exe* ../../class/lib/bootstrap
	cd ../../vbruntime && make install && cp ../class/lib/vbnc/Microsoft.VisualBasic.dll* ../class/lib/bootstrap/
	cd ../../ && make clean && make install

=== mcs/class/Microsoft.Build.Utilities/Makefile ===
thisdir = class/Microsoft.Build.Utilities
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.Build.Utilities.dll
ifeq (1.0, $(FRAMEWORK_VERSION))
LIBRARY_NAME = dummy-Microsoft.Build.Utilities.dll
NO_INSTALL = yes
NO_TEST = yes
NO_SIGN_ASSEMBLY = yes
endif

ifeq (3.5, $(FRAMEWORK_VERSION))
LIBRARY_NAME = Microsoft.Build.Utilities.v3.5.dll
endif

LIB_MCS_FLAGS = \
	/r:$(corlib)				\
	/r:System.dll				\
	/r:Microsoft.Build.Framework.dll

TEST_MCS_FLAGS = /r:Microsoft.Build.Framework.dll

include ../../build/library.make

=== mcs/class/Microsoft.JScript/Makefile ===
thisdir = class/Microsoft.JScript
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.JScript.dll
LIB_MCS_FLAGS = -r:System.dll -r:Microsoft.Vsa.dll -debug+

TEST_MCS_FLAGS = $(LIB_MCS_FLAGS) -nowarn:0618 -nowarn:219 -nowarn:169

include ../../build/library.make

=== debian/changelog ===
moon (2.2-0ubuntu1) lucid; urgency=low

  * New upstream release
  * debian/control:
    + Bump to Standards 3.8.4
    + Remove dpatch build-dep
    + We now only work on Mono arches, so use the list of Mono arches rather
      than Arch:any
    + Recommend on browsers rather than depending on them
  * debian/control,
    debian/libmoonlight-*.install:
    + Create new packages for Moonlight system assemblies (e.g. for desktop
      apps to embed Moonlight content)
  * debian/control,
    debian/moonlight-desktop-devel.install:
    + Create new package with pcfiles for moonlight desktop app compilation
  * debian/control,
    debian/moonlight-web-devel.install:
    + Create new package for Moonlight SDK
  * debian/rules:
    + Rewrite, port to fully DH7 format
  * debian/rules,
    debian/control:
    + Build only a bridge for Xulrunner 1.9.2 for now
  * debian/monodoc-moonlight-manual.install:
    + Create manual package for GTK# widget assembly

 -- Jo Shields <directhex@apebox.org>  Tue, 09 Mar 2010 15:21:48 +0000

moon (1.0.1-3) unstable; urgency=low

  * debian/control:
    + Tweak formatting (Thanks to Gerfried Fuchs)
  * debian/patches/moon_fix_gdk_pointer_size.dpatch:
    + Minor fix from Moonlight trunk to fix browser crashes with fullscreen
      controls on 64-bit platforms such as amd64, caused by missing GDK
      definitions. Thanks to Rolf Kvinge, Chris Toshok and Geoff Norton.

 -- Jo Shields <directhex@apebox.org>  Wed, 22 Apr 2009 21:43:55 +0100

moon (1.0.1-2) unstable; urgency=low

  * Build using xulrunner-dev only, not xulrunner-1.9-dev | xulrunner-dev,
    as Debian buildds won't cope with the piped build-depend

 -- Jo Shields <directhex@apebox.org>  Wed, 11 Mar 2009 09:49:12 +0000

moon (1.0.1-1) unstable; urgency=low

  * New upstream release
  * debian/copyright:
    + Updated copyright year.

 -- Jo Shields <directhex@apebox.org>  Wed, 11 Mar 2009 00:53:34 +0000

moon (1.0~beta1-1) unstable; urgency=low

  [ Jo Shields ]
  * Initial packaging (Closes: #501190)
    + Split plugin package from bridge package
    + Fresh debian/rules file, with some sections based on
      debian-multimedia (no ccache et al)
    + More liberal dependencies, depend on underlying Xulrunner rather
      than specific Iceweasel
    + Tighten inter-package dependencies to make it more NMU-safe
    + Make more distro-agnostic use of dh_link, to help Ubuntu
  * debian/rules,
    debian/patches/moon_dont_bail_on_unknown_arches.diff:
    + Patch configure.ac and re-autoconf to ensure arches other than 
      i386 and amd64 compile fine (LP: #330917)

  [ Christian Marillat ]
  * Initial packaging.
    + Due to overlapping work, the following files were used in part or 
      used for reference, and modified where appropriate:
      - debian/rules
      - debian/control
      - debian/copyright

  [ Mirco Bauer ]
  * debian/copyright:
    + Reviewed copyright and licenses of the complete source code and updated
      where needed.

  [ Stefan Ebner ]
  * debian/rules: Replace deprecated dh_clean -k with dh_prep
    to make lintian happy

 -- Mirco Bauer <meebey@debian.org>  Tue, 10 Mar 2009 22:25:06 +0100

=== debian/control ===
Source: moon
Section: web
Priority: optional
Maintainer: Moonlight packaging team <moonlight-team@lists.launchpad.net>
Uploaders: Jo Shields <directhex@apebox.org>
Homepage: http://www.mono-project.com/Moonlight
Vcs-Bzr: https://code.launchpad.net/~moonlight-team/+junk/master
Vcs-Browser: http://bazaar.launchpad.net/~moonlight-team/+junk/master/files
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 7.0.50~), 
 xulrunner-dev (>= 1.9.2),
 libavcodec-dev, 
 cli-common-dev,
 libgtk2.0-dev, 
 libasound2-dev, 
 chrpath, 
 bison,
 zip,
 autoconf,
 automake,
 libtool,
 lsb-release, 
 libpulse-dev, 
 libcairo2-dev (>= 1.8),
 autoconf,
 automake,
 autotools-dev,
 libgtk2.0-cil-dev,
 libglade2.0-cil-dev,
 libglib2.0-cil-dev,
 libwnck1.0-cil-dev,
 libmono-cil-dev,
 libtool

Package: moonlight-plugin-core
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: moonlight
Description: Free Software clone of Silverlight 2.0 - plugin core components
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the core plugin components (for any browser)

Package: moonlight-plugin-mozilla
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, moonlight-plugin-core (= ${binary:Version}), ${misc:Depends}
Recommends: firefox | abrowser | iceweasel | xulrunner-1.9.2
Conflicts: moonlight
Xb-Npp-Applications: ec8030f7-c20a-464f-9b0e-13a3a9e97384,92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a,aa5ca914-c309-495d-91cf-3141bbb04115
Xb-Npp-MimeType: application/x-silverlight,application/x-silverlight-2
Xb-Npp-Name: Novell Moonlight
Xb-Npp-File: libmoonloader.so
Xb-Npp-Description: Browser plugin for Silverlight 2.0 (http://www.mono-project.com/Moonlight)
Description: Free Software clone of Silverlight 2.0 - Xulrunner 1.9 plugin
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Xulrunner 1.9 plugin bridge, for full use with
 Xulrunner 1.9 browsers such as Firefox/Iceweasel 3, Epiphany-Gecko, HulaHop, 
 and others.

Package: libmoon
Section: libs
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Free Software clone of Silverlight 2.0 - unstable runtime library
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains required runtime files.

Package: monodoc-moonlight-manual
Section: libs
Architecture: all
Depends: monodoc-manual, ${misc:Depends}
Description: Free Software clone of Silverlight - desktop library documentation
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the compiled XML documentation for Moonlight.Gtk
 of MonoDoc.

Package: libmoonlight-windows-desktop3.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight Moon.Windows.Desktop library
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Moon.Windows.Desktop assembly.

Package: libmoonlight-gtk3.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight.Gtk library
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Moonlight.Gtk assembly, for integrating Moonlight
 content into GTK# applications.

Package: libmoonlight-system-windows3.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight System.Windows libraries
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the System.Windows assemblies.

Package: libmoonlight-system-windows-controls2.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight System.Windows.Controls libraries
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the System.Windows.Controls assemblies.

Package: libmoonlight-desktop2.0-cil-dev
Architecture: all
Depends: 
 libmoonlight-system-windows-controls2.0-cil (= ${binary:Version}), 
 libmoonlight-system-windows3.0-cil (= ${binary:Version}), 
 libmoonlight-gtk3.0-cil (= ${binary:Version}),
 libmoonlight-windows-desktop3.0-cil (= ${binary:Version}),
 libgtk2.0-cil-dev,
 ${misc:Depends}
Suggests: monodoc-moonlight-manual
Description: Moonlight SDK for desktop apps
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains development files for writing desktop applications 
 with Moonlight, and should be used for compilation.

Package: moonlight-tools
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Various tools for Moonlight SDK
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains development tools for Moonlight.

Package: moonlight-web-devel
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: moonlight-tools
Description: Moonlight SDK for web apps
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains development files for writing web content with 
 Moonlight, and should be used for compilation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export MONO_SHARED_DIR=$(CURDIR)
DEB_CLI_API_VERSION = 2.0
MAKEFILE = $(firstword $(MAKEFILE_LIST))
DEBIAN_DIR = $(dir $(MAKEFILE))
SOURCE_DIR = $(DEBIAN_DIR)/..

DEB_VERSION = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Version | cut -d" " -f2)   
DEB_SOURCE_NAME = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Source | cut -d" " -f2)
VERSION = $(shell echo $(DEB_VERSION) | cut -d"-" -f1 | sed 's/+dfsg.*//')

include /usr/share/cli-common/cli.make

clean:
	[ ! -f mono-2-6/Makefile ] || $(MAKE) -C mono-2-6 distclean
	[ ! -f mono-basic-2-6/Makefile ] || $(MAKE) -C mono-basic-2-6 clean
	[ ! -f Makefile ] || $(MAKE) clean
	rm -fr monoprefix
	rm -f *-stamp
	# distclean misses stuff
	#find is so fucking obtuse, i give up on it & declare grep my new master
	find . -name "Makefile" | grep -v 'mono-2-6\|mono-basic-2-6' | xargs rm -f
	find -name "*.mdb" -delete
	find -name ".stamp" -delete
	rm -f mono-basic-2-6/tools/moonlight/*.exe*
	rm -fr mono-basic-2-6/class/lib/2.1/
	rm -fr mono-basic-2-6/class/lib/moonlight/
	rm -fr mono-2-6/mcs/class/lib/net_*/
	rm -f src/xaml-to-header.exe*
	rm -rf mono-2-6/mcs/tools/csharplib/out
	rm -f class/Microsoft.SilverlightControls/Controls/Resource.resources
	rm -f mono-2-6/mcs/class/System.Web.Mvc/System.Web.Mvc/Resources/MvcResources.resources
	rm -f mono-2-6/mcs/class/Managed.Windows.Forms/resources/keyboards.resources
	rm -f mono-2-6/mcs/class/Mono.Data.Sqlite/resources/SR.resources
	rm -f mono-basic-2-6/vbnc/vbnc/vbnc.vbnc.rsp
	rm -f mono-2-6/mcs/class/Novell.Directory.Ldap/Novell.Directory.Ldap.Utilclass/ResultCodeMessages.resources
	rm -f mono-2-6/mcs/class/System.Web/resources/TranslationResources.resources
	rm -f mono-2-6/mcs/class/Commons.Xml.Relaxng/Commons.Xml.Relaxng.Rnc/RncParser.cs
	rm -f mono-2-6/mcs/class/Commons.Xml.Relaxng/y.output
	rm -f mono-2-6/mcs/class/Mono.WebBrowser/Mono.WebBrowser2K5.csproj
	rm -f class/System.Windows.Controls/*.resources
	rm -f mono-2-6/mcs/class/System.Data/Mono.Data.SqlExpressions/Parser.cs
	rm -f mono-2-6/mcs/class/System.Web/System.Web/UplevelHelper.cs
	rm -f mono-2-6/mcs/class/System.XML/Mono.Xml.Xsl/PatternParser.jay
	rm -f mono-2-6/mcs/class/corlib/net_1_1_aot.log
	rm -rf mono-2-6/mcs/build/deps/
	rm -f mono-2-6/dolt*
	rm -f stamp-h1
	rm -f config.h config.log config.status dolt* libtool
	rm -f mono-2-6/mcs/build/config.make
	rm -f plugin/install/install.rdf plugin/silverlight-versions.h
	rm -f tools/sockpol/sockpol
	rm -f moon.pc moonlight.spec
	rm -f src/codec-version.h src/drm.h src/fullscreen.h src/incomplete-support.h
	dh_prep
	dh_clean

configure: mono-install-stamp moonlight-configure-stamp

build: mono-build-stamp moonlight-build-stamp
	touch build-stamp

build-indep: build-stamp

build-arch: build-stamp

install-stamp: moonlight-build-stamp
	dh_testdir
	dh_testroot
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	install -m 644 monoprefix/lib/libmono.so.0.0.0  debian/tmp/usr/lib/moonlight/
	install -m 755 monoprefix/bin/mono  debian/tmp/usr/lib/moonlight/
	chrpath -r /usr/lib/moonlight/ $(MONO_SHARED_DIR)/debian/tmp/usr/lib/libmoon.so.0.0.0
	chrpath -r /usr/lib/moonlight/ $(MONO_SHARED_DIR)/debian/tmp/usr/lib/moonlight/plugin/libmoonplugin.so
	dh_install --list-missing
	touch install-stamp

mono-install-stamp: mono-build-stamp
	cd mono-2-6 && $(MAKE) install

	#manually insert GTK# into monoprefix GAC
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/gtk-sharp-2.0/gtk-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/atk-sharp-2.0/atk-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/gdk-sharp-2.0/gdk-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/glib-sharp-2.0/glib-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/gtk-dotnet-2.0/gtk-dotnet.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/pango-sharp-2.0/pango-sharp.dll

	touch mono-install-stamp

mono-build-stamp: mono-configure-stamp
	cd mono-2-6 && $(MAKE)
	touch mono-build-stamp

mono-configure-stamp:
	cd mono-2-6 && ./configure --prefix=$(MONO_SHARED_DIR)/monoprefix
	touch mono-configure-stamp

moonlight-build-stamp: moonlight-configure-stamp
	PATH=$(MONO_SHARED_DIR)/monoprefix/bin:$(PATH) $(MAKE)
	touch moonlight-build-stamp	

moonlight-configure-stamp: mono-install-stamp
	autoreconf
	PKG_CONFIG_PATH=$(MONO_SHARED_DIR)/monoprefix/lib/pkgconfig ./configure --with-mcspath=$(MONO_SHARED_DIR)/mono-2-6/mcs --with-mono-basic-path=$(MONO_SHARED_DIR)/mono-basic-2-6 --with-cairo=system --with-ff36=yes --with-ff3=no --prefix=/usr
	touch moonlight-configure-stamp

get-orig-source:
	uscan \
		--package $(DEB_SOURCE_NAME) \
		--watchfile $(DEBIAN_DIR)/watch \
		--upstream-version $(VERSION) \
		--download-version $(VERSION) \
		--destdir . \
		--force-download \
		--rename
	wget -c http://ftp.novell.com/pub/mono/sources/moon/$(VERSION)/mono-2.6.1.tar.bz2 
	wget -c http://ftp.novell.com/pub/mono/sources/moon/$(VERSION)/mono-basic-2.6.tar.bz2 
	mv mono-2.6.1.tar.bz2 ./moon_$(VERSION).orig-mono-2-6.tar.bz2
	mv mono-basic-2.6.tar.bz2 ./moon_$(VERSION).orig-mono-basic-2-6.tar.bz2

binary: install-stamp

binary-arch: install-stamp

override_dh_makeshlibs:
	dh_makeshlibs
	dh_makeshlibs -p libmoon -V'libmoon (>= $(VERSION)), libmoon (<< $(VERSION).)'

override_dh_makeclilibs:
	dh_makeclilibs -V

%:
	dh $@

.PHONY: build build-arch build-indep

=== debian/watch ===
version=3
opts=uversionmangle=s/([.\d]+)b/$1~beta/ \
 http://ftp.novell.com/pub/mono/sources/moon/(\d.\d)/moonlight-([\.\d]+)\.tar\.bz2
